#ifndef __included_hpp_l2_api_json
#define __included_hpp_l2_api_json

#include <vapi/vapi.hpp>
#include <vapi/l2.api.vapi.h>

namespace vapi {

template <> inline void vapi_swap_to_be<vapi_msg_l2_flags>(vapi_msg_l2_flags *msg)
{
  vapi_msg_l2_flags_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_flags>(vapi_msg_l2_flags *msg)
{
  vapi_msg_l2_flags_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_flags>()
{
  return ::vapi_msg_id_l2_flags; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_flags>>()
{
  return ::vapi_msg_id_l2_flags; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_flags()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_flags>(vapi_msg_id_l2_flags);
}

template <> inline vapi_msg_l2_flags* vapi_alloc<vapi_msg_l2_flags>(Connection &con)
{
  vapi_msg_l2_flags* result = vapi_alloc_l2_flags(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2_flags>;

template class Request<vapi_msg_l2_flags, vapi_msg_l2_flags_reply>;

using L2_flags = Request<vapi_msg_l2_flags, vapi_msg_l2_flags_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2fib_flush_all>(vapi_msg_l2fib_flush_all *msg)
{
  vapi_msg_l2fib_flush_all_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_flush_all>(vapi_msg_l2fib_flush_all *msg)
{
  vapi_msg_l2fib_flush_all_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_flush_all>()
{
  return ::vapi_msg_id_l2fib_flush_all; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_flush_all>>()
{
  return ::vapi_msg_id_l2fib_flush_all; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_flush_all()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_flush_all>(vapi_msg_id_l2fib_flush_all);
}

template <> inline vapi_msg_l2fib_flush_all* vapi_alloc<vapi_msg_l2fib_flush_all>(Connection &con)
{
  vapi_msg_l2fib_flush_all* result = vapi_alloc_l2fib_flush_all(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2fib_flush_all>;

template class Request<vapi_msg_l2fib_flush_all, vapi_msg_l2fib_flush_all_reply>;

using L2fib_flush_all = Request<vapi_msg_l2fib_flush_all, vapi_msg_l2fib_flush_all_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2_fib_table_dump>(vapi_msg_l2_fib_table_dump *msg)
{
  vapi_msg_l2_fib_table_dump_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_fib_table_dump>(vapi_msg_l2_fib_table_dump *msg)
{
  vapi_msg_l2_fib_table_dump_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_fib_table_dump>()
{
  return ::vapi_msg_id_l2_fib_table_dump; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_fib_table_dump>>()
{
  return ::vapi_msg_id_l2_fib_table_dump; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_fib_table_dump()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_fib_table_dump>(vapi_msg_id_l2_fib_table_dump);
}

template <> inline vapi_msg_l2_fib_table_dump* vapi_alloc<vapi_msg_l2_fib_table_dump>(Connection &con)
{
  vapi_msg_l2_fib_table_dump* result = vapi_alloc_l2_fib_table_dump(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2_fib_table_dump>;

template class Dump<vapi_msg_l2_fib_table_dump, vapi_msg_l2_fib_table_details>;

using L2_fib_table_dump = Dump<vapi_msg_l2_fib_table_dump, vapi_msg_l2_fib_table_details>;

template <> inline void vapi_swap_to_be<vapi_msg_bridge_domain_dump>(vapi_msg_bridge_domain_dump *msg)
{
  vapi_msg_bridge_domain_dump_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_domain_dump>(vapi_msg_bridge_domain_dump *msg)
{
  vapi_msg_bridge_domain_dump_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_domain_dump>()
{
  return ::vapi_msg_id_bridge_domain_dump; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_domain_dump>>()
{
  return ::vapi_msg_id_bridge_domain_dump; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_domain_dump()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_domain_dump>(vapi_msg_id_bridge_domain_dump);
}

template <> inline vapi_msg_bridge_domain_dump* vapi_alloc<vapi_msg_bridge_domain_dump>(Connection &con)
{
  vapi_msg_bridge_domain_dump* result = vapi_alloc_bridge_domain_dump(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_bridge_domain_dump>;

template class Dump<vapi_msg_bridge_domain_dump, vapi_msg_bridge_domain_details>;

using Bridge_domain_dump = Dump<vapi_msg_bridge_domain_dump, vapi_msg_bridge_domain_details>;

template <> inline void vapi_swap_to_be<vapi_msg_l2_xconnect_details>(vapi_msg_l2_xconnect_details *msg)
{
  vapi_msg_l2_xconnect_details_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_xconnect_details>(vapi_msg_l2_xconnect_details *msg)
{
  vapi_msg_l2_xconnect_details_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_xconnect_details>()
{
  return ::vapi_msg_id_l2_xconnect_details; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_xconnect_details>>()
{
  return ::vapi_msg_id_l2_xconnect_details; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_xconnect_details()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_xconnect_details>(vapi_msg_id_l2_xconnect_details);
}

template class Msg<vapi_msg_l2_xconnect_details>;

using L2_xconnect_details = Msg<vapi_msg_l2_xconnect_details>;
template <> inline void vapi_swap_to_be<vapi_msg_l2fib_add_del_reply>(vapi_msg_l2fib_add_del_reply *msg)
{
  vapi_msg_l2fib_add_del_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_add_del_reply>(vapi_msg_l2fib_add_del_reply *msg)
{
  vapi_msg_l2fib_add_del_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_add_del_reply>()
{
  return ::vapi_msg_id_l2fib_add_del_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_add_del_reply>>()
{
  return ::vapi_msg_id_l2fib_add_del_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_add_del_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_add_del_reply>(vapi_msg_id_l2fib_add_del_reply);
}

template class Msg<vapi_msg_l2fib_add_del_reply>;

using L2fib_add_del_reply = Msg<vapi_msg_l2fib_add_del_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2fib_flush_bd_reply>(vapi_msg_l2fib_flush_bd_reply *msg)
{
  vapi_msg_l2fib_flush_bd_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_flush_bd_reply>(vapi_msg_l2fib_flush_bd_reply *msg)
{
  vapi_msg_l2fib_flush_bd_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_flush_bd_reply>()
{
  return ::vapi_msg_id_l2fib_flush_bd_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_flush_bd_reply>>()
{
  return ::vapi_msg_id_l2fib_flush_bd_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_flush_bd_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_flush_bd_reply>(vapi_msg_id_l2fib_flush_bd_reply);
}

template class Msg<vapi_msg_l2fib_flush_bd_reply>;

using L2fib_flush_bd_reply = Msg<vapi_msg_l2fib_flush_bd_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_interface_pbb_tag_rewrite>(vapi_msg_l2_interface_pbb_tag_rewrite *msg)
{
  vapi_msg_l2_interface_pbb_tag_rewrite_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_interface_pbb_tag_rewrite>(vapi_msg_l2_interface_pbb_tag_rewrite *msg)
{
  vapi_msg_l2_interface_pbb_tag_rewrite_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_interface_pbb_tag_rewrite>()
{
  return ::vapi_msg_id_l2_interface_pbb_tag_rewrite; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_interface_pbb_tag_rewrite>>()
{
  return ::vapi_msg_id_l2_interface_pbb_tag_rewrite; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_interface_pbb_tag_rewrite()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_interface_pbb_tag_rewrite>(vapi_msg_id_l2_interface_pbb_tag_rewrite);
}

template <> inline vapi_msg_l2_interface_pbb_tag_rewrite* vapi_alloc<vapi_msg_l2_interface_pbb_tag_rewrite>(Connection &con)
{
  vapi_msg_l2_interface_pbb_tag_rewrite* result = vapi_alloc_l2_interface_pbb_tag_rewrite(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2_interface_pbb_tag_rewrite>;

template class Request<vapi_msg_l2_interface_pbb_tag_rewrite, vapi_msg_l2_interface_pbb_tag_rewrite_reply>;

using L2_interface_pbb_tag_rewrite = Request<vapi_msg_l2_interface_pbb_tag_rewrite, vapi_msg_l2_interface_pbb_tag_rewrite_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2fib_flush_int_reply>(vapi_msg_l2fib_flush_int_reply *msg)
{
  vapi_msg_l2fib_flush_int_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_flush_int_reply>(vapi_msg_l2fib_flush_int_reply *msg)
{
  vapi_msg_l2fib_flush_int_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_flush_int_reply>()
{
  return ::vapi_msg_id_l2fib_flush_int_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_flush_int_reply>>()
{
  return ::vapi_msg_id_l2fib_flush_int_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_flush_int_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_flush_int_reply>(vapi_msg_id_l2fib_flush_int_reply);
}

template class Msg<vapi_msg_l2fib_flush_int_reply>;

using L2fib_flush_int_reply = Msg<vapi_msg_l2fib_flush_int_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_bridge_domain_add_del_reply>(vapi_msg_bridge_domain_add_del_reply *msg)
{
  vapi_msg_bridge_domain_add_del_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_domain_add_del_reply>(vapi_msg_bridge_domain_add_del_reply *msg)
{
  vapi_msg_bridge_domain_add_del_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_domain_add_del_reply>()
{
  return ::vapi_msg_id_bridge_domain_add_del_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_domain_add_del_reply>>()
{
  return ::vapi_msg_id_bridge_domain_add_del_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_domain_add_del_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_domain_add_del_reply>(vapi_msg_id_bridge_domain_add_del_reply);
}

template class Msg<vapi_msg_bridge_domain_add_del_reply>;

using Bridge_domain_add_del_reply = Msg<vapi_msg_bridge_domain_add_del_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_bridge_flags_reply>(vapi_msg_bridge_flags_reply *msg)
{
  vapi_msg_bridge_flags_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_flags_reply>(vapi_msg_bridge_flags_reply *msg)
{
  vapi_msg_bridge_flags_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_flags_reply>()
{
  return ::vapi_msg_id_bridge_flags_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_flags_reply>>()
{
  return ::vapi_msg_id_bridge_flags_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_flags_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_flags_reply>(vapi_msg_id_bridge_flags_reply);
}

template class Msg<vapi_msg_bridge_flags_reply>;

using Bridge_flags_reply = Msg<vapi_msg_bridge_flags_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2fib_flush_bd>(vapi_msg_l2fib_flush_bd *msg)
{
  vapi_msg_l2fib_flush_bd_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_flush_bd>(vapi_msg_l2fib_flush_bd *msg)
{
  vapi_msg_l2fib_flush_bd_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_flush_bd>()
{
  return ::vapi_msg_id_l2fib_flush_bd; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_flush_bd>>()
{
  return ::vapi_msg_id_l2fib_flush_bd; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_flush_bd()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_flush_bd>(vapi_msg_id_l2fib_flush_bd);
}

template <> inline vapi_msg_l2fib_flush_bd* vapi_alloc<vapi_msg_l2fib_flush_bd>(Connection &con)
{
  vapi_msg_l2fib_flush_bd* result = vapi_alloc_l2fib_flush_bd(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2fib_flush_bd>;

template class Request<vapi_msg_l2fib_flush_bd, vapi_msg_l2fib_flush_bd_reply>;

using L2fib_flush_bd = Request<vapi_msg_l2fib_flush_bd, vapi_msg_l2fib_flush_bd_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2fib_flush_int>(vapi_msg_l2fib_flush_int *msg)
{
  vapi_msg_l2fib_flush_int_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_flush_int>(vapi_msg_l2fib_flush_int *msg)
{
  vapi_msg_l2fib_flush_int_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_flush_int>()
{
  return ::vapi_msg_id_l2fib_flush_int; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_flush_int>>()
{
  return ::vapi_msg_id_l2fib_flush_int; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_flush_int()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_flush_int>(vapi_msg_id_l2fib_flush_int);
}

template <> inline vapi_msg_l2fib_flush_int* vapi_alloc<vapi_msg_l2fib_flush_int>(Connection &con)
{
  vapi_msg_l2fib_flush_int* result = vapi_alloc_l2fib_flush_int(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2fib_flush_int>;

template class Request<vapi_msg_l2fib_flush_int, vapi_msg_l2fib_flush_int_reply>;

using L2fib_flush_int = Request<vapi_msg_l2fib_flush_int, vapi_msg_l2fib_flush_int_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2_fib_table_details>(vapi_msg_l2_fib_table_details *msg)
{
  vapi_msg_l2_fib_table_details_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_fib_table_details>(vapi_msg_l2_fib_table_details *msg)
{
  vapi_msg_l2_fib_table_details_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_fib_table_details>()
{
  return ::vapi_msg_id_l2_fib_table_details; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_fib_table_details>>()
{
  return ::vapi_msg_id_l2_fib_table_details; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_fib_table_details()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_fib_table_details>(vapi_msg_id_l2_fib_table_details);
}

template class Msg<vapi_msg_l2_fib_table_details>;

using L2_fib_table_details = Msg<vapi_msg_l2_fib_table_details>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_fib_clear_table_reply>(vapi_msg_l2_fib_clear_table_reply *msg)
{
  vapi_msg_l2_fib_clear_table_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_fib_clear_table_reply>(vapi_msg_l2_fib_clear_table_reply *msg)
{
  vapi_msg_l2_fib_clear_table_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_fib_clear_table_reply>()
{
  return ::vapi_msg_id_l2_fib_clear_table_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_fib_clear_table_reply>>()
{
  return ::vapi_msg_id_l2_fib_clear_table_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_fib_clear_table_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_fib_clear_table_reply>(vapi_msg_id_l2_fib_clear_table_reply);
}

template class Msg<vapi_msg_l2_fib_clear_table_reply>;

using L2_fib_clear_table_reply = Msg<vapi_msg_l2_fib_clear_table_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_bridge_domain_set_mac_age>(vapi_msg_bridge_domain_set_mac_age *msg)
{
  vapi_msg_bridge_domain_set_mac_age_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_domain_set_mac_age>(vapi_msg_bridge_domain_set_mac_age *msg)
{
  vapi_msg_bridge_domain_set_mac_age_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_domain_set_mac_age>()
{
  return ::vapi_msg_id_bridge_domain_set_mac_age; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_domain_set_mac_age>>()
{
  return ::vapi_msg_id_bridge_domain_set_mac_age; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_domain_set_mac_age()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_domain_set_mac_age>(vapi_msg_id_bridge_domain_set_mac_age);
}

template <> inline vapi_msg_bridge_domain_set_mac_age* vapi_alloc<vapi_msg_bridge_domain_set_mac_age>(Connection &con)
{
  vapi_msg_bridge_domain_set_mac_age* result = vapi_alloc_bridge_domain_set_mac_age(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_bridge_domain_set_mac_age>;

template class Request<vapi_msg_bridge_domain_set_mac_age, vapi_msg_bridge_domain_set_mac_age_reply>;

using Bridge_domain_set_mac_age = Request<vapi_msg_bridge_domain_set_mac_age, vapi_msg_bridge_domain_set_mac_age_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2fib_flush_all_reply>(vapi_msg_l2fib_flush_all_reply *msg)
{
  vapi_msg_l2fib_flush_all_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_flush_all_reply>(vapi_msg_l2fib_flush_all_reply *msg)
{
  vapi_msg_l2fib_flush_all_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_flush_all_reply>()
{
  return ::vapi_msg_id_l2fib_flush_all_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_flush_all_reply>>()
{
  return ::vapi_msg_id_l2fib_flush_all_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_flush_all_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_flush_all_reply>(vapi_msg_id_l2fib_flush_all_reply);
}

template class Msg<vapi_msg_l2fib_flush_all_reply>;

using L2fib_flush_all_reply = Msg<vapi_msg_l2fib_flush_all_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_macs_event>(vapi_msg_l2_macs_event *msg)
{
  vapi_msg_l2_macs_event_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_macs_event>(vapi_msg_l2_macs_event *msg)
{
  vapi_msg_l2_macs_event_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_macs_event>()
{
  return ::vapi_msg_id_l2_macs_event; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_macs_event>>()
{
  return ::vapi_msg_id_l2_macs_event; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_macs_event()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_macs_event>(vapi_msg_id_l2_macs_event);
}

template class Msg<vapi_msg_l2_macs_event>;

using L2_macs_event = Msg<vapi_msg_l2_macs_event>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_flags_reply>(vapi_msg_l2_flags_reply *msg)
{
  vapi_msg_l2_flags_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_flags_reply>(vapi_msg_l2_flags_reply *msg)
{
  vapi_msg_l2_flags_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_flags_reply>()
{
  return ::vapi_msg_id_l2_flags_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_flags_reply>>()
{
  return ::vapi_msg_id_l2_flags_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_flags_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_flags_reply>(vapi_msg_id_l2_flags_reply);
}

template class Msg<vapi_msg_l2_flags_reply>;

using L2_flags_reply = Msg<vapi_msg_l2_flags_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_fib_clear_table>(vapi_msg_l2_fib_clear_table *msg)
{
  vapi_msg_l2_fib_clear_table_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_fib_clear_table>(vapi_msg_l2_fib_clear_table *msg)
{
  vapi_msg_l2_fib_clear_table_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_fib_clear_table>()
{
  return ::vapi_msg_id_l2_fib_clear_table; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_fib_clear_table>>()
{
  return ::vapi_msg_id_l2_fib_clear_table; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_fib_clear_table()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_fib_clear_table>(vapi_msg_id_l2_fib_clear_table);
}

template <> inline vapi_msg_l2_fib_clear_table* vapi_alloc<vapi_msg_l2_fib_clear_table>(Connection &con)
{
  vapi_msg_l2_fib_clear_table* result = vapi_alloc_l2_fib_clear_table(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2_fib_clear_table>;

template class Request<vapi_msg_l2_fib_clear_table, vapi_msg_l2_fib_clear_table_reply>;

using L2_fib_clear_table = Request<vapi_msg_l2_fib_clear_table, vapi_msg_l2_fib_clear_table_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2_interface_vlan_tag_rewrite_reply>(vapi_msg_l2_interface_vlan_tag_rewrite_reply *msg)
{
  vapi_msg_l2_interface_vlan_tag_rewrite_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_interface_vlan_tag_rewrite_reply>(vapi_msg_l2_interface_vlan_tag_rewrite_reply *msg)
{
  vapi_msg_l2_interface_vlan_tag_rewrite_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_interface_vlan_tag_rewrite_reply>()
{
  return ::vapi_msg_id_l2_interface_vlan_tag_rewrite_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_interface_vlan_tag_rewrite_reply>>()
{
  return ::vapi_msg_id_l2_interface_vlan_tag_rewrite_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_interface_vlan_tag_rewrite_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_interface_vlan_tag_rewrite_reply>(vapi_msg_id_l2_interface_vlan_tag_rewrite_reply);
}

template class Msg<vapi_msg_l2_interface_vlan_tag_rewrite_reply>;

using L2_interface_vlan_tag_rewrite_reply = Msg<vapi_msg_l2_interface_vlan_tag_rewrite_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_bridge_flags>(vapi_msg_bridge_flags *msg)
{
  vapi_msg_bridge_flags_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_flags>(vapi_msg_bridge_flags *msg)
{
  vapi_msg_bridge_flags_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_flags>()
{
  return ::vapi_msg_id_bridge_flags; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_flags>>()
{
  return ::vapi_msg_id_bridge_flags; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_flags()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_flags>(vapi_msg_id_bridge_flags);
}

template <> inline vapi_msg_bridge_flags* vapi_alloc<vapi_msg_bridge_flags>(Connection &con)
{
  vapi_msg_bridge_flags* result = vapi_alloc_bridge_flags(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_bridge_flags>;

template class Request<vapi_msg_bridge_flags, vapi_msg_bridge_flags_reply>;

using Bridge_flags = Request<vapi_msg_bridge_flags, vapi_msg_bridge_flags_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_l2fib_add_del>(vapi_msg_l2fib_add_del *msg)
{
  vapi_msg_l2fib_add_del_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2fib_add_del>(vapi_msg_l2fib_add_del *msg)
{
  vapi_msg_l2fib_add_del_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2fib_add_del>()
{
  return ::vapi_msg_id_l2fib_add_del; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2fib_add_del>>()
{
  return ::vapi_msg_id_l2fib_add_del; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2fib_add_del()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2fib_add_del>(vapi_msg_id_l2fib_add_del);
}

template <> inline vapi_msg_l2fib_add_del* vapi_alloc<vapi_msg_l2fib_add_del>(Connection &con)
{
  vapi_msg_l2fib_add_del* result = vapi_alloc_l2fib_add_del(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2fib_add_del>;

template class Request<vapi_msg_l2fib_add_del, vapi_msg_l2fib_add_del_reply>;

using L2fib_add_del = Request<vapi_msg_l2fib_add_del, vapi_msg_l2fib_add_del_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_bridge_domain_set_mac_age_reply>(vapi_msg_bridge_domain_set_mac_age_reply *msg)
{
  vapi_msg_bridge_domain_set_mac_age_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_domain_set_mac_age_reply>(vapi_msg_bridge_domain_set_mac_age_reply *msg)
{
  vapi_msg_bridge_domain_set_mac_age_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_domain_set_mac_age_reply>()
{
  return ::vapi_msg_id_bridge_domain_set_mac_age_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_domain_set_mac_age_reply>>()
{
  return ::vapi_msg_id_bridge_domain_set_mac_age_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_domain_set_mac_age_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_domain_set_mac_age_reply>(vapi_msg_id_bridge_domain_set_mac_age_reply);
}

template class Msg<vapi_msg_bridge_domain_set_mac_age_reply>;

using Bridge_domain_set_mac_age_reply = Msg<vapi_msg_bridge_domain_set_mac_age_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_want_l2_macs_events>(vapi_msg_want_l2_macs_events *msg)
{
  vapi_msg_want_l2_macs_events_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_want_l2_macs_events>(vapi_msg_want_l2_macs_events *msg)
{
  vapi_msg_want_l2_macs_events_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_want_l2_macs_events>()
{
  return ::vapi_msg_id_want_l2_macs_events; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_want_l2_macs_events>>()
{
  return ::vapi_msg_id_want_l2_macs_events; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_want_l2_macs_events()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_want_l2_macs_events>(vapi_msg_id_want_l2_macs_events);
}

template <> inline vapi_msg_want_l2_macs_events* vapi_alloc<vapi_msg_want_l2_macs_events>(Connection &con)
{
  vapi_msg_want_l2_macs_events* result = vapi_alloc_want_l2_macs_events(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_want_l2_macs_events>;

template class Request<vapi_msg_want_l2_macs_events, vapi_msg_want_l2_macs_events_reply>;

using Want_l2_macs_events = Request<vapi_msg_want_l2_macs_events, vapi_msg_want_l2_macs_events_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_bridge_domain_add_del>(vapi_msg_bridge_domain_add_del *msg)
{
  vapi_msg_bridge_domain_add_del_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_domain_add_del>(vapi_msg_bridge_domain_add_del *msg)
{
  vapi_msg_bridge_domain_add_del_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_domain_add_del>()
{
  return ::vapi_msg_id_bridge_domain_add_del; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_domain_add_del>>()
{
  return ::vapi_msg_id_bridge_domain_add_del; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_domain_add_del()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_domain_add_del>(vapi_msg_id_bridge_domain_add_del);
}

template <> inline vapi_msg_bridge_domain_add_del* vapi_alloc<vapi_msg_bridge_domain_add_del>(Connection &con)
{
  vapi_msg_bridge_domain_add_del* result = vapi_alloc_bridge_domain_add_del(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_bridge_domain_add_del>;

template class Request<vapi_msg_bridge_domain_add_del, vapi_msg_bridge_domain_add_del_reply>;

using Bridge_domain_add_del = Request<vapi_msg_bridge_domain_add_del, vapi_msg_bridge_domain_add_del_reply>;

template <> inline void vapi_swap_to_be<vapi_msg_bridge_domain_details>(vapi_msg_bridge_domain_details *msg)
{
  vapi_msg_bridge_domain_details_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_bridge_domain_details>(vapi_msg_bridge_domain_details *msg)
{
  vapi_msg_bridge_domain_details_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_bridge_domain_details>()
{
  return ::vapi_msg_id_bridge_domain_details; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_bridge_domain_details>>()
{
  return ::vapi_msg_id_bridge_domain_details; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_bridge_domain_details()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_bridge_domain_details>(vapi_msg_id_bridge_domain_details);
}

template class Msg<vapi_msg_bridge_domain_details>;

using Bridge_domain_details = Msg<vapi_msg_bridge_domain_details>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_interface_pbb_tag_rewrite_reply>(vapi_msg_l2_interface_pbb_tag_rewrite_reply *msg)
{
  vapi_msg_l2_interface_pbb_tag_rewrite_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_interface_pbb_tag_rewrite_reply>(vapi_msg_l2_interface_pbb_tag_rewrite_reply *msg)
{
  vapi_msg_l2_interface_pbb_tag_rewrite_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_interface_pbb_tag_rewrite_reply>()
{
  return ::vapi_msg_id_l2_interface_pbb_tag_rewrite_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_interface_pbb_tag_rewrite_reply>>()
{
  return ::vapi_msg_id_l2_interface_pbb_tag_rewrite_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_interface_pbb_tag_rewrite_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_interface_pbb_tag_rewrite_reply>(vapi_msg_id_l2_interface_pbb_tag_rewrite_reply);
}

template class Msg<vapi_msg_l2_interface_pbb_tag_rewrite_reply>;

using L2_interface_pbb_tag_rewrite_reply = Msg<vapi_msg_l2_interface_pbb_tag_rewrite_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_xconnect_dump>(vapi_msg_l2_xconnect_dump *msg)
{
  vapi_msg_l2_xconnect_dump_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_xconnect_dump>(vapi_msg_l2_xconnect_dump *msg)
{
  vapi_msg_l2_xconnect_dump_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_xconnect_dump>()
{
  return ::vapi_msg_id_l2_xconnect_dump; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_xconnect_dump>>()
{
  return ::vapi_msg_id_l2_xconnect_dump; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_xconnect_dump()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_xconnect_dump>(vapi_msg_id_l2_xconnect_dump);
}

template <> inline vapi_msg_l2_xconnect_dump* vapi_alloc<vapi_msg_l2_xconnect_dump>(Connection &con)
{
  vapi_msg_l2_xconnect_dump* result = vapi_alloc_l2_xconnect_dump(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2_xconnect_dump>;

template class Dump<vapi_msg_l2_xconnect_dump, vapi_msg_l2_xconnect_details>;

using L2_xconnect_dump = Dump<vapi_msg_l2_xconnect_dump, vapi_msg_l2_xconnect_details>;

template <> inline void vapi_swap_to_be<vapi_msg_want_l2_macs_events_reply>(vapi_msg_want_l2_macs_events_reply *msg)
{
  vapi_msg_want_l2_macs_events_reply_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_want_l2_macs_events_reply>(vapi_msg_want_l2_macs_events_reply *msg)
{
  vapi_msg_want_l2_macs_events_reply_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_want_l2_macs_events_reply>()
{
  return ::vapi_msg_id_want_l2_macs_events_reply; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_want_l2_macs_events_reply>>()
{
  return ::vapi_msg_id_want_l2_macs_events_reply; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_want_l2_macs_events_reply()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_want_l2_macs_events_reply>(vapi_msg_id_want_l2_macs_events_reply);
}

template class Msg<vapi_msg_want_l2_macs_events_reply>;

using Want_l2_macs_events_reply = Msg<vapi_msg_want_l2_macs_events_reply>;
template <> inline void vapi_swap_to_be<vapi_msg_l2_interface_vlan_tag_rewrite>(vapi_msg_l2_interface_vlan_tag_rewrite *msg)
{
  vapi_msg_l2_interface_vlan_tag_rewrite_hton(msg);
}

template <> inline void vapi_swap_to_host<vapi_msg_l2_interface_vlan_tag_rewrite>(vapi_msg_l2_interface_vlan_tag_rewrite *msg)
{
  vapi_msg_l2_interface_vlan_tag_rewrite_ntoh(msg);
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<vapi_msg_l2_interface_vlan_tag_rewrite>()
{
  return ::vapi_msg_id_l2_interface_vlan_tag_rewrite; 
}

template <> inline vapi_msg_id_t vapi_get_msg_id_t<Msg<vapi_msg_l2_interface_vlan_tag_rewrite>>()
{
  return ::vapi_msg_id_l2_interface_vlan_tag_rewrite; 
}

static void __attribute__((constructor)) __vapi_cpp_constructor_l2_interface_vlan_tag_rewrite()
{
  vapi::vapi_msg_set_msg_id<vapi_msg_l2_interface_vlan_tag_rewrite>(vapi_msg_id_l2_interface_vlan_tag_rewrite);
}

template <> inline vapi_msg_l2_interface_vlan_tag_rewrite* vapi_alloc<vapi_msg_l2_interface_vlan_tag_rewrite>(Connection &con)
{
  vapi_msg_l2_interface_vlan_tag_rewrite* result = vapi_alloc_l2_interface_vlan_tag_rewrite(con.vapi_ctx);
#if VAPI_CPP_DEBUG_LEAKS
  con.on_shm_data_alloc(result);
#endif
  return result;
}

template class Msg<vapi_msg_l2_interface_vlan_tag_rewrite>;

template class Request<vapi_msg_l2_interface_vlan_tag_rewrite, vapi_msg_l2_interface_vlan_tag_rewrite_reply>;

using L2_interface_vlan_tag_rewrite = Request<vapi_msg_l2_interface_vlan_tag_rewrite, vapi_msg_l2_interface_vlan_tag_rewrite_reply>;

}
#endif
