#ifndef __included_memclnt_api_json
#define __included_memclnt_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_get_first_msg_id;
extern vapi_msg_id_t vapi_msg_id_get_first_msg_id_reply;
extern vapi_msg_id_t vapi_msg_id_memclnt_delete_reply;
extern vapi_msg_id_t vapi_msg_id_memclnt_create_reply;
extern vapi_msg_id_t vapi_msg_id_rpc_call_reply;

#define DEFINE_VAPI_MSG_IDS_MEMCLNT_API_JSON\
  vapi_msg_id_t vapi_msg_id_get_first_msg_id;\
  vapi_msg_id_t vapi_msg_id_get_first_msg_id_reply;\
  vapi_msg_id_t vapi_msg_id_memclnt_delete_reply;\
  vapi_msg_id_t vapi_msg_id_memclnt_create_reply;\
  vapi_msg_id_t vapi_msg_id_rpc_call_reply;


typedef struct __attribute__ ((__packed__)) {
  u8 name[64]; 
} vapi_payload_get_first_msg_id;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_get_first_msg_id payload;
} vapi_msg_get_first_msg_id;

typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u16 first_msg_id; 
} vapi_payload_get_first_msg_id_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_get_first_msg_id_reply payload;
} vapi_msg_get_first_msg_id_reply;

typedef struct __attribute__ ((__packed__)) {
  u16 _vl_msg_id;
  i32 response;
  u64 handle; 
} vapi_payload_memclnt_delete_reply;

typedef struct __attribute__ ((__packed__)) {

  vapi_payload_memclnt_delete_reply payload;
} vapi_msg_memclnt_delete_reply;

typedef struct __attribute__ ((__packed__)) {
  u16 _vl_msg_id;
  i32 response;
  u64 handle;
  u32 index;
  u32 context;
  u64 message_table; 
} vapi_payload_memclnt_create_reply;

typedef struct __attribute__ ((__packed__)) {

  vapi_payload_memclnt_create_reply payload;
} vapi_msg_memclnt_create_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_rpc_call_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_rpc_call_reply payload;
} vapi_msg_rpc_call_reply;


static inline void vapi_msg_get_first_msg_id_payload_hton(vapi_payload_get_first_msg_id *payload)
{

}

static inline void vapi_msg_get_first_msg_id_payload_ntoh(vapi_payload_get_first_msg_id *payload)
{

}

static inline uword vapi_calc_get_first_msg_id_msg_size(vapi_msg_get_first_msg_id *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_first_msg_id_hton(vapi_msg_get_first_msg_id *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_first_msg_id'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_get_first_msg_id_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_first_msg_id_ntoh(vapi_msg_get_first_msg_id *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_first_msg_id'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_get_first_msg_id_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_get_first_msg_id_reply_payload_hton(vapi_payload_get_first_msg_id_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->first_msg_id = htobe16(payload->first_msg_id);
}

static inline void vapi_msg_get_first_msg_id_reply_payload_ntoh(vapi_payload_get_first_msg_id_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->first_msg_id = be16toh(payload->first_msg_id);
}

static inline uword vapi_calc_get_first_msg_id_reply_msg_size(vapi_msg_get_first_msg_id_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_get_first_msg_id_reply_hton(vapi_msg_get_first_msg_id_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_first_msg_id_reply'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_get_first_msg_id_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_get_first_msg_id_reply_ntoh(vapi_msg_get_first_msg_id_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_get_first_msg_id_reply'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_get_first_msg_id_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_memclnt_delete_reply_payload_hton(vapi_payload_memclnt_delete_reply *payload)
{
  payload->_vl_msg_id = htobe16(payload->_vl_msg_id);
  payload->response = htobe32(payload->response);
  payload->handle = htobe64(payload->handle);
}

static inline void vapi_msg_memclnt_delete_reply_payload_ntoh(vapi_payload_memclnt_delete_reply *payload)
{
  payload->_vl_msg_id = be16toh(payload->_vl_msg_id);
  payload->response = be32toh(payload->response);
  payload->handle = be64toh(payload->handle);
}

static inline uword vapi_calc_memclnt_delete_reply_msg_size(vapi_msg_memclnt_delete_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_memclnt_delete_reply_hton(vapi_msg_memclnt_delete_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_memclnt_delete_reply'@%p to big endian", msg);

  vapi_msg_memclnt_delete_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_memclnt_delete_reply_ntoh(vapi_msg_memclnt_delete_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_memclnt_delete_reply'@%p to host byte order", msg);

  vapi_msg_memclnt_delete_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_memclnt_create_reply_payload_hton(vapi_payload_memclnt_create_reply *payload)
{
  payload->_vl_msg_id = htobe16(payload->_vl_msg_id);
  payload->response = htobe32(payload->response);
  payload->handle = htobe64(payload->handle);
  payload->index = htobe32(payload->index);
  payload->context = htobe32(payload->context);
  payload->message_table = htobe64(payload->message_table);
}

static inline void vapi_msg_memclnt_create_reply_payload_ntoh(vapi_payload_memclnt_create_reply *payload)
{
  payload->_vl_msg_id = be16toh(payload->_vl_msg_id);
  payload->response = be32toh(payload->response);
  payload->handle = be64toh(payload->handle);
  payload->index = be32toh(payload->index);
  payload->context = be32toh(payload->context);
  payload->message_table = be64toh(payload->message_table);
}

static inline uword vapi_calc_memclnt_create_reply_msg_size(vapi_msg_memclnt_create_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_memclnt_create_reply_hton(vapi_msg_memclnt_create_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_memclnt_create_reply'@%p to big endian", msg);

  vapi_msg_memclnt_create_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_memclnt_create_reply_ntoh(vapi_msg_memclnt_create_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_memclnt_create_reply'@%p to host byte order", msg);

  vapi_msg_memclnt_create_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_rpc_call_reply_payload_hton(vapi_payload_rpc_call_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_rpc_call_reply_payload_ntoh(vapi_payload_rpc_call_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_rpc_call_reply_msg_size(vapi_msg_rpc_call_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_rpc_call_reply_hton(vapi_msg_rpc_call_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_rpc_call_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_rpc_call_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_rpc_call_reply_ntoh(vapi_msg_rpc_call_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_rpc_call_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_rpc_call_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_get_first_msg_id* vapi_alloc_get_first_msg_id(struct vapi_ctx_s *ctx)
{
  vapi_msg_get_first_msg_id *msg = NULL;
  const size_t size = sizeof(vapi_msg_get_first_msg_id);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_get_first_msg_id*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_get_first_msg_id);

  return msg;
}

static inline vapi_error_e vapi_get_first_msg_id(struct vapi_ctx_s *ctx,
  vapi_msg_get_first_msg_id *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_get_first_msg_id_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_get_first_msg_id_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_get_first_msg_id_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_get_first_msg_id()
{
  static const char name[] = "get_first_msg_id";
  static const char name_with_crc[] = "get_first_msg_id_56f7fd40";
  static vapi_message_desc_t __vapi_metadata_get_first_msg_id = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_get_first_msg_id, payload),
    sizeof(vapi_msg_get_first_msg_id),
    (generic_swap_fn_t)vapi_msg_get_first_msg_id_hton,
    (generic_swap_fn_t)vapi_msg_get_first_msg_id_ntoh,
    ~0,
  };

  vapi_msg_id_get_first_msg_id = vapi_register_msg(&__vapi_metadata_get_first_msg_id);
  VAPI_DBG("Assigned msg id %d to get_first_msg_id", vapi_msg_id_get_first_msg_id);
}

static void __attribute__((constructor)) __vapi_constructor_get_first_msg_id_reply()
{
  static const char name[] = "get_first_msg_id_reply";
  static const char name_with_crc[] = "get_first_msg_id_reply_3c6931c6";
  static vapi_message_desc_t __vapi_metadata_get_first_msg_id_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_get_first_msg_id_reply, payload),
    sizeof(vapi_msg_get_first_msg_id_reply),
    (generic_swap_fn_t)vapi_msg_get_first_msg_id_reply_hton,
    (generic_swap_fn_t)vapi_msg_get_first_msg_id_reply_ntoh,
    ~0,
  };

  vapi_msg_id_get_first_msg_id_reply = vapi_register_msg(&__vapi_metadata_get_first_msg_id_reply);
  VAPI_DBG("Assigned msg id %d to get_first_msg_id_reply", vapi_msg_id_get_first_msg_id_reply);
}

static void __attribute__((constructor)) __vapi_constructor_memclnt_delete_reply()
{
  static const char name[] = "memclnt_delete_reply";
  static const char name_with_crc[] = "memclnt_delete_reply_587855a7";
  static vapi_message_desc_t __vapi_metadata_memclnt_delete_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    false,
    0,
    offsetof(vapi_msg_memclnt_delete_reply, payload),
    sizeof(vapi_msg_memclnt_delete_reply),
    (generic_swap_fn_t)vapi_msg_memclnt_delete_reply_hton,
    (generic_swap_fn_t)vapi_msg_memclnt_delete_reply_ntoh,
    ~0,
  };

  vapi_msg_id_memclnt_delete_reply = vapi_register_msg(&__vapi_metadata_memclnt_delete_reply);
  VAPI_DBG("Assigned msg id %d to memclnt_delete_reply", vapi_msg_id_memclnt_delete_reply);
}

static void __attribute__((constructor)) __vapi_constructor_memclnt_create_reply()
{
  static const char name[] = "memclnt_create_reply";
  static const char name_with_crc[] = "memclnt_create_reply_f71a8a1a";
  static vapi_message_desc_t __vapi_metadata_memclnt_create_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    false,
    0,
    offsetof(vapi_msg_memclnt_create_reply, payload),
    sizeof(vapi_msg_memclnt_create_reply),
    (generic_swap_fn_t)vapi_msg_memclnt_create_reply_hton,
    (generic_swap_fn_t)vapi_msg_memclnt_create_reply_ntoh,
    ~0,
  };

  vapi_msg_id_memclnt_create_reply = vapi_register_msg(&__vapi_metadata_memclnt_create_reply);
  VAPI_DBG("Assigned msg id %d to memclnt_create_reply", vapi_msg_id_memclnt_create_reply);
}

static void __attribute__((constructor)) __vapi_constructor_rpc_call_reply()
{
  static const char name[] = "rpc_call_reply";
  static const char name_with_crc[] = "rpc_call_reply_45621c6a";
  static vapi_message_desc_t __vapi_metadata_rpc_call_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_rpc_call_reply, payload),
    sizeof(vapi_msg_rpc_call_reply),
    (generic_swap_fn_t)vapi_msg_rpc_call_reply_hton,
    (generic_swap_fn_t)vapi_msg_rpc_call_reply_ntoh,
    ~0,
  };

  vapi_msg_id_rpc_call_reply = vapi_register_msg(&__vapi_metadata_rpc_call_reply);
  VAPI_DBG("Assigned msg id %d to rpc_call_reply", vapi_msg_id_rpc_call_reply);
}


static inline void vapi_set_vapi_msg_get_first_msg_id_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_get_first_msg_id_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_get_first_msg_id_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_memclnt_delete_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_memclnt_delete_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_memclnt_delete_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_memclnt_create_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_memclnt_create_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_memclnt_create_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_rpc_call_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_rpc_call_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_rpc_call_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
