#ifndef __included_udp_ping_api_json
#define __included_udp_ping_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_udp_ping_export_reply;
extern vapi_msg_id_t vapi_msg_id_udp_ping_add_del_reply;

#define DEFINE_VAPI_MSG_IDS_UDP_PING_API_JSON\
  vapi_msg_id_t vapi_msg_id_udp_ping_export_reply;\
  vapi_msg_id_t vapi_msg_id_udp_ping_add_del_reply;


typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_udp_ping_export_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_udp_ping_export_reply payload;
} vapi_msg_udp_ping_export_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_udp_ping_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_udp_ping_add_del_reply payload;
} vapi_msg_udp_ping_add_del_reply;


static inline void vapi_msg_udp_ping_export_reply_payload_hton(vapi_payload_udp_ping_export_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_udp_ping_export_reply_payload_ntoh(vapi_payload_udp_ping_export_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_udp_ping_export_reply_msg_size(vapi_msg_udp_ping_export_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_udp_ping_export_reply_hton(vapi_msg_udp_ping_export_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_ping_export_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_udp_ping_export_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_udp_ping_export_reply_ntoh(vapi_msg_udp_ping_export_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_ping_export_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_udp_ping_export_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_udp_ping_add_del_reply_payload_hton(vapi_payload_udp_ping_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_udp_ping_add_del_reply_payload_ntoh(vapi_payload_udp_ping_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_udp_ping_add_del_reply_msg_size(vapi_msg_udp_ping_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_udp_ping_add_del_reply_hton(vapi_msg_udp_ping_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_ping_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_udp_ping_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_udp_ping_add_del_reply_ntoh(vapi_msg_udp_ping_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_udp_ping_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_udp_ping_add_del_reply_payload_ntoh(&msg->payload);
}


static void __attribute__((constructor)) __vapi_constructor_udp_ping_export_reply()
{
  static const char name[] = "udp_ping_export_reply";
  static const char name_with_crc[] = "udp_ping_export_reply_7f8a6c87";
  static vapi_message_desc_t __vapi_metadata_udp_ping_export_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_udp_ping_export_reply, payload),
    sizeof(vapi_msg_udp_ping_export_reply),
    (generic_swap_fn_t)vapi_msg_udp_ping_export_reply_hton,
    (generic_swap_fn_t)vapi_msg_udp_ping_export_reply_ntoh,
    ~0,
  };

  vapi_msg_id_udp_ping_export_reply = vapi_register_msg(&__vapi_metadata_udp_ping_export_reply);
  VAPI_DBG("Assigned msg id %d to udp_ping_export_reply", vapi_msg_id_udp_ping_export_reply);
}

static void __attribute__((constructor)) __vapi_constructor_udp_ping_add_del_reply()
{
  static const char name[] = "udp_ping_add_del_reply";
  static const char name_with_crc[] = "udp_ping_add_del_reply_a08dec44";
  static vapi_message_desc_t __vapi_metadata_udp_ping_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_udp_ping_add_del_reply, payload),
    sizeof(vapi_msg_udp_ping_add_del_reply),
    (generic_swap_fn_t)vapi_msg_udp_ping_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_udp_ping_add_del_reply_ntoh,
    ~0,
  };

  vapi_msg_id_udp_ping_add_del_reply = vapi_register_msg(&__vapi_metadata_udp_ping_add_del_reply);
  VAPI_DBG("Assigned msg id %d to udp_ping_add_del_reply", vapi_msg_id_udp_ping_add_del_reply);
}


static inline void vapi_set_vapi_msg_udp_ping_export_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_udp_ping_export_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_udp_ping_export_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_udp_ping_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_udp_ping_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_udp_ping_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
